/*    fgrab_pci.h  -- header for PCI specific code for generic frame grabber
 *    
 *    See file COPYING for copyright info
 *
 */

/* Include file for pci interface used by some fgrab modules		    */

#include <linux/pci.h>

/* PCI-related #defines */
/* Jim Lowe suggests 32, or 16 if bus master slots > 4 */
#define FGRAB_LATENCY 72

struct fgrab_pci {
    unsigned int minor;
    u_short index;
    u_char bus;
    u_char dev_fn;
    unsigned int addr;
    unsigned pci_vendor_id;
    unsigned pci_device_id;
} ;

struct pci_progs {
    void (*setup)(struct fgrab_pci *pci,int irq, unsigned minor) ;
    int (*detect)(int (*dev_register)(int irq, void *data, 
                                      struct fgrab_pci *pci),
                  int (*dev_signature)(void *data),
                  void *data,
                  unsigned int pci_vendor_id,unsigned int pci_device_id,
                  unsigned int window_size) ;
    void (*unwind)(unsigned minor) ;
    unsigned (*check_bus)(unsigned minor) ;
    void (*enable_dma)(unsigned minor) ;
    void (*disable_dma)(unsigned minor) ;
    void *(*get_addr)(unsigned minor) ;
} ;

#ifndef FGRAB_PCI_INTERNAL
extern struct pci_progs fgrab_pci_progs ;
#endif

#define FGRAB_MINOR_SETUP MAXFGRABS

/*
 * Following is from drivers/scsi/hosts.c of 2.0.18.
 * Overrides for Emacs so that we follow Linus's tabbing style.
 * Emacs will notice this stuff at the end of the file and automatically
 * adjust the settings for this buffer only.  This must remain at the end
 * of the file.
 * ---------------------------------------------------------------------------
 * Local variables:
 * c-indent-level: 4
 * c-brace-imaginary-offset: 0
 * c-brace-offset: -4
 * c-argdecl-indent: 4
 * c-label-offset: -4
 * c-continued-statement-offset: 4
 * c-continued-brace-offset: 0
 * indent-tabs-mode: nil
 * tab-width: 8
 * End:
 */
