/*    meteor.h  -- Meteor board specific include file of Generic Frame Grabber.
 *    
 *    See file COPYING for copyright info
 *
 */

/* Get rid of DEBUG_METEOR once the driver works for you. */
/*#define DEBUG_METEOR */

/* Uncomment if you want FIFO overflow and DMA address error messages. */
/*#define SHOW_CAPT_ERRORS */


#define METEOR_INTERLACE_FIELDS	0x00000000
#define METEOR_ONLY_EVEN_FIELDS	0x01000000
#define METEOR_ONLY_ODD_FIELDS	0x02000000
#define METEOR_ALTERNATE_FIELDS	0x03000000
#define METEOR_FIELDS_MASK  	0x03000000

#define METEOR_RGB 		0x20000000
#define METEOR_NO_RESAMP	0x40000000

#define	METEOR_NTSC		0x00000100
#define	METEOR_PAL		0x00000200
#define	METEOR_SECAM		0x00000400
#define	METEOR_AUTOMODE		0x00000800
#define	METEOR_FORM_MASK	0x00000f00

#define METEOR_DT315X_ID_R	(((0x1f)<<1) + 1)	/* DT315X I2C ID register		*/

#define METEOR_WAIT_JIFFS ((HZ*10+999)/1000+1)		/* Should be about 10 to 20 milliseconds */



struct meteor	{
    struct saa7116 saa7116;	/* structure private to saa7116 code  	*/
    struct saa7196 saa7196;	/* structure private to saa7196 code  	*/
    struct bt254   bt254  ;	/* structure private to bt254 code  	*/
    u_long maxRange;		/* maximum range-checkable size 	*/
    u_char bus;			/* PCI bus, for doing PCI commands 	*/
    u_char dev_fn;		/* PCI dev_fn, for doing PCI commands 	*/
    u_char irq;			/* IRQ 					*/
    u_long minor;		/* minor device number for this board	*/
    u_long flags;		/* a couple of flags			*/
    u_short rows;		/* number of rows in recorded image	*/
    u_short cols;		/* number of cols in recorded image	*/
    unsigned bus_errors;	/* cumulative bus erors since open	*/
    unsigned ext_bus_errors;	/* cumulative external erors since open	*/
    } ;

#define METEOR_VERSION "0.1"


