#include <stdio.h>
static void set_pixel_clock(unsigned minor, unsigned freq) ;
static unsigned get_pixel_clock(unsigned minor) ;
struct dt3152_clk_divider { 
    unsigned div:4; 
    unsigned ex_clk_inv:1; 
    unsigned clk_mode:1; 
    unsigned :2;
} ;
main() {
unsigned freq;
while (1) {
    if (fscanf(stdin,"%d",&freq)!=1) exit(1);
    set_pixel_clock(0,freq);
    fprintf(stdout,"%d\n",get_pixel_clock(0));
    }
}
unsigned char bval[6];
struct dt3152_clk_divider clk_div ;

/* reverse_bits is used by the pixel_clock routines     */
static unsigned reverse_bits(unsigned in) {
    unsigned out;
    int i;
    out = 0;
    for (i=0;i<8;i++) {
        out = out<<1 | (in&0x1) ;
        in >>= 1 ;
    }
    return(out);
}

static void set_pixel_clock(unsigned minor, unsigned freq) {
    unsigned div, pcnt, rcnt, ncnt, factor, fp, fvcoem1;
    int del, min_del, i;
    unsigned min_ncnt, min_rcnt, min_pcnt;
#if 0
    struct dt3152_clk_divider clk_div ;
    unsigned char bval[6];
#endif
    if (freq>20000000) freq = 20000000;
    if (freq<1000) freq = 1000;
    for (div=0,factor=2;( freq*factor ) <= 20000000;div++,factor <<= 1) {
        if (div==0xf) break;
    }
    fp = freq*factor;
    if (fp<20000000) fp = 20000000 ;
    min_del = fp ;
    for (pcnt=((130000000/fp)-1);
	 pcnt>=((65000000+fp-1)/fp)-1;
	 pcnt--) {
        fvcoem1 = (fp*(pcnt+1))/10 ;
        for (rcnt=28;rcnt<=50;rcnt++) {
            for (ncnt=(fvcoem1*rcnt)/2000000;ncnt<=((fvcoem1+1)*rcnt)/2000000;ncnt++) {
                del = (2000000*ncnt)/(rcnt*(pcnt+1))-fp ;
                del = (del<0) ? -del : del ;
                if (del < min_del) {
                    min_ncnt = ncnt ;
                    min_rcnt = rcnt ;
                    min_pcnt = pcnt ;
                    min_del  = del  ;
                }
            }
        }
    }
    bval[0] = 0xd4 ;
#   define DP8534_RESET 0x10
    bval[1] = ((min_pcnt&0x1)<<7) | 0x20 ;
    bval[2] = ((min_pcnt>>1)&0x7) | ((min_rcnt&0x1)<<7) ;
    bval[3] = (min_rcnt>>1)&0xff ;
    bval[4] = ((min_rcnt>>9)&0x1) | ((min_ncnt&0x7f)<<1) ;
    bval[5] = ((min_ncnt>>7)&0x7f) | 0x80 ;
    clk_div = (struct dt3152_clk_divider){div:div, ex_clk_inv:0, clk_mode:0} ;
fprintf(stderr,"pcnt=0x%x rcnt=0x%x ncnt=0x%x div=0x%x\n",min_pcnt,min_rcnt,min_ncnt,div);
fprintf(stderr,"pcnt=%d rcnt=%d ncnt=%d div=%d\n",min_pcnt,min_rcnt,min_ncnt,div);
for (i=5;i>=0;i--) fprintf(stderr,"%.2x ",reverse_bits(bval[i])); fprintf(stderr,"\n");
#if 0
    for (i=0;i<=4;i++) {
        talk_i2c(minor,_IIC_W(DT3152_CLOCK1),0,reverse_bits(bval[i]));
    }
    talk_i2c(minor,_IIC_W(DT3152_CLOCK2),0,reverse_bits(bval[5]));
    talk_i2c(minor,_IIC_W(DT3152_CLK_DIVIDER),0,(unsigned char)clk_div);
#endif
}

static unsigned get_pixel_clock(unsigned minor) {
    unsigned div, pcnt, rcnt, ncnt, factor, freq;
    int i;
#if 0
    struct dt3152_clk_divider clk_div ;
    unsigned char bval[6];
    talk_i2c(minor,_IIC_R(DT3152_CLOCK2),0,0);
    bval[0] = reverse_bits(get_i2c(minor));
    for (i=1;i<=5;i++) {
        talk_i2c(minor,_IIC_R(DT3152_CLOCK1),0,0);
        bval[i] = reverse_bits(get_i2c(minor));
    }
#endif
    pcnt = ((bval[1]>>7)&0x1) | ((bval[2]&0x7)<<1) ;
    rcnt = ((bval[2]>>7)&0x1) | ((bval[3]&0xff)<<1) | ((bval[4]&0x1)<<9) ;
    ncnt = ((bval[4]>>1)&0x7f) | ((bval[5]&0x7f)<<7) ;
#if 0
    talk_i2c(minor,_IIC_R(DT3152_CLK_DIVIDER),0,0);
    clk_div = (struct dt3152_clk_divider)get_i2c(minor) ;
#endif
    div = clk_div.div ;
fprintf(stderr,"pcnt=0x%x rcnt=0x%x ncnt=0x%x div=0x%x\n",pcnt,rcnt,ncnt,div);
    factor = (0x2)<<div ;
    freq = ((2000000*ncnt)/(rcnt*(pcnt+1)*factor))*10 ;
    return(freq);
}
