/*
 *	ioctl functions that are specific to the meteor board
 *    
 *    See file COPYING for copyright info
 *
 */

#define METEORSBT254 	_IOW('x', 64+0, unsigned short)	/* set Bt254 reg */
#define METEORGBT254 	_IOR('x', 64+0, unsigned short)	/* get Bt254 reg */
#define	METEORGCAPT  	_IOR('x', 64+1, unsigned long)  /* get saa7116 capt_ctl (0x40) register */
#define	METEORRESAMP  	_IO('x',  64+2)	/* set meteor to do resampling (default) */
#define	METEORNORESAMP  _IO('x',  64+3)	/* set meteor to not do resampling	 */
#define METEORSTATUS    _IOR('x', 64+5, unsigned short)	/* get status 	 */

#define	METEOR_STATUS_ID_MASK	0xf000	/* ID of 7196 */
#define	METEOR_STATUS_DIR	0x0800	/* Direction of Expansion port YUV */
#define	METEOR_STATUS_OEF	0x0200	/* Field detected: Even/Odd */
#define	METEOR_STATUS_SVP	0x0100	/* State of VRAM Port:inactive/active */
#define	METEOR_STATUS_STTC	0x0080	/* Time Constant: TV/VCR */
#define	METEOR_STATUS_HCLK	0x0040	/* Horiz PLL: locked/unlocked */
#define	METEOR_STATUS_FIDT	0x0020	/* Field detect: 50/60hz */
#define	METEOR_STATUS_ALTD	0x0002	/* Line alt: no line alt/line alt */
#define METEOR_STATUS_CODE	0x0001	/* Colour info: no colour/colour */

#define METEOR_INPUT_DEV_RCA	FGRAB_INPUT_DEV0
