/* User include file for backwards compatibility with routines
   written for original meteor driver
 */
#include "fgrab_ioctl.h"
#include "meteor_ioctl.h"

#ifndef _MACHINE_IOCTL_METEOR_H
#define _MACHINE_IOCTL_METEOR_H

#define meteor_capframe 	fgrab_capframe
#define meteor_geomet		fgrab_geomet
#define meteor_counts		fgrab_counts
#define meteor_frame_offset 	fgrab_frame_offset
#define meteor_video 		fgrab_video

#define METEORCAPTUR		FGRABCAPTUR
#define METEORCAPFRM		FGRABCAPFRM
#define METEORSETGEO		FGRABSETGEO
#define METEORGETGEO		FGRABGETGEO
#define METEORSHUE  		FGRABSHUE  
#define METEORGHUE  		FGRABGHUE  
#define METEORSFMT  		FGRABSFMT  
#define METEORGFMT  		FGRABGFMT  
#define METEORSINPUT		FGRABSINPUT
#define METEORGINPUT		FGRABGINPUT
#define	METEORSCHCV 		FGRABSCHCV 
#define	METEORGCHCV 		FGRABGCHCV 
#define	METEORSCOUNT		FGRABSCOUNT
#define	METEORGCOUNT		FGRABGCOUNT
#define METEORSFPS  		FGRABSFPS  
#define METEORGFPS  		FGRABGFPS  
#define METEORSSIGNAL		FGRABSSIGNAL
#define METEORGSIGNAL		FGRABGSIGNAL
#define	METEORSVIDEO		FGRABSVIDEO
#define	METEORGVIDEO		FGRABGVIDEO
#define	METEORSBRIG 		FGRABSBRIG 
#define METEORGBRIG 		FGRABGBRIG 
#define	METEORSCSAT 		FGRABSCSAT 
#define METEORGCSAT 		FGRABGCSAT 
#define	METEORSCONT 		FGRABSCONT 
#define	METEORGCONT 		FGRABGCONT 
#define METEORSHWS  		FGRABSHWS  
#define METEORGHWS  		FGRABGHWS  
#define METEORSVWS  		FGRABSVWS  
#define METEORGVWS  		FGRABGVWS  
#define	METEORSTS   		FGRABSTS   
#define	METEORGTS   		FGRABGTS   
#define	METEORGFROFF		FGRABGFROFF

#define METEOR_CAP_SINGLE	FGRAB_CAP_SINGLE
#define METEOR_CAP_CONTINOUS	FGRAB_CAP_CONTINOUS
#define METEOR_CAP_STOP_CONT	FGRAB_CAP_STOP_CONT
#define METEOR_CAP_CONT_ONCE	FGRAB_CAP_CONT_ONCE

#define METEOR_CAP_N_FRAMES	FGRAB_CAP_N_FRAMES
#define METEOR_CAP_STOP_FRAMES	FGRAB_CAP_STOP_FRAMES
#define	METEOR_HALT_N_FRAMES	FGRAB_HALT_N_FRAMES
#define METEOR_CONT_N_FRAMES	FGRAB_CONT_N_FRAMES

#define METEOR_FMT_NTSC		FGRAB_FMT_NTSC
#define METEOR_FMT_PAL		FGRAB_FMT_PAL
#define METEOR_FMT_SECAM	FGRAB_FMT_SECAM
#define METEOR_FMT_AUTOMODE	FGRAB_FMT_AUTOMODE
#define METEOR_INPUT_DEV0	FGRAB_INPUT_DEV0
#define METEOR_INPUT_DEV1	FGRAB_INPUT_DEV1
#define METEOR_INPUT_DEV2	FGRAB_INPUT_DEV2
#define METEOR_INPUT_DEV3	FGRAB_INPUT_DEV3
#define METEOR_INPUT_DEV_RGB	FGRAB_INPUT_DEV_RGB
#define METEOR_INPUT_DEV_SVIDEO	FGRAB_INPUT_DEV_SVIDEO

#define METEOR_GEO_RGB16	FGRAB_GEO_RGB16
#define METEOR_GEO_RGB24	FGRAB_GEO_RGB24
#define METEOR_GEO_YUV_PACKED	FGRAB_GEO_YUV_PACKED
#define METEOR_GEO_YUV_PLANAR	FGRAB_GEO_YUV_PLANAR
#define METEOR_GEO_YUV_PLANER	METEOR_GEO_YUV_PLANAR
#define METEOR_GEO_UNSIGNED	FGRAB_GEO_UNSIGNED
#define METEOR_GEO_EVEN_ONLY	FGRAB_GEO_EVEN_ONLY
#define METEOR_GEO_ODD_ONLY	FGRAB_GEO_ODD_ONLY
#define METEOR_GEO_FIELD_MASK	FGRAB_GEO_FIELD_MASK
#define METEOR_GEO_YUV_422	FGRAB_GEO_YUV_422
#define METEOR_GEO_OUTPUT_MASK	FGRAB_GEO_OUTPUT_MASK
#define METEOR_GEO_YUV_12	FGRAB_GEO_YUV_12
#define METEOR_GEO_YUV_9	FGRAB_GEO_YUV_9

#define METEOR_FIELD_MODE       FGRAB_GEO_ALTERNATE

#define METEOR_SIG_MODE_MASK    FGRAB_SIG_MODE_MASK
#define METEOR_SIG_FRAME        FGRAB_SIG_FRAME
#define METEOR_SIG_FIELD        FGRAB_SIG_FIELD


#define meteor_mem		fgrab_mem

#endif /* ifndef _MACHINE_IOCTL_METEOR_H */

